#include<iostream>
using namespace std;

void sortowaniePrzezWstawianie(int n, int *tab) //Opiera się na prostej zasadzie: jeśli dwa elementy są ustawione w złej kolejności (większy przed mniejszym), należy je zamienić miejscami.
{
     int pom, j;
     for(int i=1; i<n; i++)
     {
             //wstawienie elementu w odpowiednie miejsce
             pom = tab[i]; //ten element będzie wstawiony w odpowiednie miejsce
             j = i-1;

             //przesuwanie elementów większych od pom
             while(j>=0 && tab[j]>pom)
             {
                        tablica[j+1] = tab[j]; //przesuwanie elementów
                        --j;
             }
             tablica[j+1] = pom; //wstawienie pom w odpowiednie miejsce
     }
}

int main()
{
    int n, *tabica;
    cout<<"Podaj wielkosc zbioru: "; //podanie ile liczb będzie sortowana
    cin>>n;

    tablica = new int [n];

    for(int i=0; i<n; i++)
    {
            cout<<"Podaj "<<i+1<<" element: ";
            cin>>tab[i];
    }

    cout<<"Elementy przed sortowaniem:\n";
    for(int i=0; i<n; i++)
            cout<<tab[i]<<" ";

    sortowaniePrzezWstawianie(n, tab);

    cout<<"\nElementy posortowaniu:\n";
    for(int i=0; i<n; i++)
            cout<<tab[i]<<" ";

    cin.ignore();
    cin.get();
    return 0;
}
